Index: resources/typ-files/mapnik.txt
===================================================================
--- resources/typ-files/mapnik.txt	(revisión: 4431)
+++ resources/typ-files/mapnik.txt	(copia de trabajo)
@@ -83,6 +83,7 @@
 String1=0x01,Résidentiel
 String2=0x02,Wohngebiet
 String4=0x03,Bebouwing
+String5=0x08,Zona habitada
 String7=0x15,Obszar mieszkalny
 String8=0x10,Residencial
 String9=0x05,Area residenziale
@@ -99,6 +100,7 @@
 String1=0x01,Résidentiel
 String2=0x02,Wohngebiet
 String4=0x03,Bebouwing
+String5=0x08,Zona habitada
 String7=0x15,Obszar mieszkalny
 String8=0x10,Residencial
 String9=0x05,Area residenziale
@@ -115,6 +117,7 @@
 String1=0x01,Domaine militaire
 String2=0x02,Militärisches Sperrgebiet
 String4=0x03,Militair domein
+String5=0x08,Terreno militar
 String7=0x15,Teren wojskowy
 String8=0x10,Militar
 String9=0x05,Area militare
@@ -183,6 +186,7 @@
 String2=0x02,Garagen
 String3=0x04,Parking
 String4=0x03,Garages
+String5=0x08,Aparcamiento (cubierto)
 String7=0x15,Garaże
 String8=0x10,Garagem
 String9=0x05,Garage
@@ -199,6 +203,7 @@
 String1=0x01,Aéroport
 String2=0x02,Flughafen
 String4=0x03,Vliegveld
+String5=0x08,Aeropuerto
 String7=0x15,Lotnisko
 String8=0x10,Aeroporto
 String9=0x05,Aerodromo
@@ -215,6 +220,7 @@
 String1=0x01,Zone commerciale
 String2=0x02,Gewerbegebiet
 String4=0x03,Commercieel gebied
+String5=0x08,Cafetería/Tiendas
 String7=0x15,Obszar handlowy
 String8=0x10,Área comercial
 String9=0x05,Area commerciale
@@ -232,6 +238,7 @@
 String2=0x02,Schwimmbad
 String3=0x04,Water Park
 String4=0x03,Zwembad
+String5=0x08,Marina/Parque acuático
 String7=0x15,Basen
 String8=0x10,Piscina
 String9=0x05,Piscina
@@ -249,6 +256,7 @@
 String2=0x02,Schule
 String3=0x04,Education
 String4=0x03,School
+String5=0x08,Enseñanza
 String7=0x15,Edukacja
 String8=0x10,Escola
 String9=0x05,Scuola
@@ -265,6 +273,7 @@
 String1=0x01,Hôpital
 String2=0x02,Krankenhaus
 String4=0x03,Ziekenhuis
+String5=0x08,Hospital
 String7=0x15,Szpital
 String8=0x10,Hospital
 String9=0x05,Ospedale
@@ -282,6 +291,7 @@
 String2=0x02,Industriegebiet
 String3=0x04,Industrial area
 String4=0x03,Industriegebied
+String5=0x08,Polígono industrial
 String7=0x15,Obszar przemysłowy
 String8=0x10,Área industrial
 String9=0x05,Area industriale
@@ -1198,6 +1208,7 @@
 String1=0x01,Autoroute
 String2=0x02,Autobahn
 String4=0x03,Snelweg
+String5=0x08,Autopista
 String7=0x15,Autostrada
 String8=0x10,Autoestrada
 String9=0x05,Autostrada
@@ -1218,6 +1229,7 @@
 String1=0x01,Voie rapide
 String2=0x02,Schnellstraße
 String4=0x03,Autoweg
+String5=0x08,Carretera troncal
 String7=0x15,Droga szybkiego ruchu
 String8=0x10,Via expressa
 String9=0x05,Superstrada
@@ -1238,6 +1250,7 @@
 String1=0x01,Route primaire
 String2=0x02,Bundesstraße
 String4=0x03,Primair
+String5=0x08,Carretera primaria
 String7=0x15,Droga krajowa
 String8=0x10,Via primária
 String9=0x05,Strada principale
@@ -1258,6 +1271,7 @@
 String1=0x01,Route secondaire
 String2=0x02,Bundesstraße
 String4=0x03,Secundair
+String5=0x08,Carretera secundaria
 String7=0x15,Droga wojewódzka
 String8=0x10,Via secundária
 String9=0x05,Strada principale
@@ -1278,6 +1292,7 @@
 String1=0x01,Route tertiaire
 String2=0x02,Straße
 String4=0x03,Tertiair
+String5=0x08,Carretera terciaria
 String7=0x15,Droga powiatowa
 String8=0x10,Via terciária
 String9=0x05,Strada
@@ -1298,6 +1313,7 @@
 String1=0x01,Rue
 String2=0x02,Straße
 String4=0x03,Weg
+String5=0x08,Vía urbana
 String7=0x15,Droga
 String8=0x10,Residencial
 String9=0x05,Strada residenziale
@@ -1318,6 +1334,7 @@
 String1=0x01,Rue
 String2=0x02,Straße
 String4=0x03,Straat
+String5=0x08,Vía de servicio
 String7=0x15,Ulica
 String8=0x10,Rua
 String9=0x05,Strada
@@ -1339,6 +1356,7 @@
 String1=0x01,Voie d’accès
 String2=0x02,Bundesstraße (Verbindung)
 String4=0x03,Secundair (Verbinding)
+String5=0x08,Enlace de via menor
 String7=0x15,Droga wojewódzka (łącznik)
 String8=0x10,Ligação de via secundária
 String9=0x05,Strada principale (collegamento)
@@ -1359,6 +1377,7 @@
 String1=0x01,Voie d’accès
 String2=0x02,Schnellstraße (verbindung)
 String4=0x03,Autoweg (Verbinding)
+String5=0x08,Enlace de vía principal
 String7=0x15,Droga szybkiego ruchu  (łącznik)
 String8=0x10,Ligação de via expressa
 String9=0x05,Superstrada (collegamento)
@@ -1381,6 +1400,7 @@
 String2=0x02,Unbefestigt
 String3=0x04,Track (Grade unknown)
 String4=0x03,Veldweg (Onbekend)
+String5=0x08,Pista sin pavimento
 String7=0x15,Droga gruntowa (klasa nieznana)
 String8=0x10,Estrada agrícola
 String9=0x05,Sentiero carrabile
@@ -1401,6 +1421,7 @@
 String1=0x01,Voie d’accès
 String2=0x02,Schnellstraße (verbindung)
 String4=0x03,Autoweg (Verbinding)
+String5=0x08,Enlace de vía
 String7=0x15,Droga szybkiego ruchu  (łącznik)
 String8=0x10,Ligação de via expressa
 String9=0x05,Superstrada (collegamento)
@@ -1421,6 +1442,7 @@
 String1=0x01,Rond point
 String2=0x02,Kreisverkehr
 String4=0x03,Rotonde
+String5=0x08,Rotonda
 String7=0x15,Rondo
 String8=0x10,Rotatória
 String9=0x05,Rotatoria
@@ -1442,6 +1464,7 @@
 String1=0x01,Piste cyclable
 String2=0x02,Radweg
 String4=0x03,Fietspad
+String5=0x08,Carril bici
 String7=0x15,Ścieżka rowerowa
 String8=0x10,Ciclovia
 String9=0x05,Pista ciclabile
@@ -1466,6 +1489,7 @@
 String2=0x02,Gleis
 String3=0x04,Railway
 String4=0x03,Spoorweg
+String5=0x08,Ferrocarril
 String7=0x15,Kolej
 String8=0x10,Ferrovia
 String9=0x05,Ferrovia
@@ -1477,7 +1501,7 @@
 type=0x15
 ;GRMN_TYPE: Misc. Line Types/SHORELINE/Shoreline of water body (typically only used when a water area is not available)/Non NT
 UseOrientation=N
-Xpm="32 1 2  1"
+Xpm="32 1 2 1"
 "! c #000000"
 "  c none"
 "                                "
@@ -1486,6 +1510,7 @@
 String1=0x01,Littoral
 String2=0x02,Küstelinien
 String4=0x03,Kustlijn
+String5=0x08,Línea de costa
 String7=0x15,Wybrzeże
 String8=0x10,Litoral / Costal
 String9=0x05,Costa
@@ -1498,7 +1523,7 @@
 type=0x16
 ;GRMN_TYPE: Roads/TRAIL/Walkway or trail/Non NT, NT
 UseOrientation=N
-Xpm="32 1 2  1"
+Xpm="32 1 2 1"
 "! c #FF0000"
 "  c none"
 "  !!!!!   !!!!!   !!!!!   !!!!! "
@@ -1524,6 +1549,7 @@
 "1 c #AAAAAA"
 String=Barrier
 String4=0x03,Barrière
+String5=0x08,Barrera
 ExtendedLabels=Y
 FontStyle=NoLabel (invisible)
 CustomColor=No
@@ -1539,6 +1565,7 @@
 String1=0x01,Ruisseau
 String2=0x02,Bach
 String4=0x03,Beek
+String5=0x08,Arroyo
 String7=0x15,Strumień
 String8=0x10,Córrego
 String9=0x05,Ruscello
@@ -1560,6 +1587,7 @@
 String1=0x01,Ferry
 String2=0x02,Fähre
 String4=0x03,Ferry
+String5=0x08,Ferry
 String7=0x15,Prom
 String8=0x10,Balsa
 String9=0x05,Traghetto
@@ -1581,6 +1609,7 @@
 String1=0x01,Ferry
 String2=0x02,Fähre
 String4=0x03,Ferry
+String5=0x08,Ferry
 String7=0x15,Prom
 String8=0x10,Balsa
 String9=0x05,Traghetto
@@ -1611,6 +1640,7 @@
 String2=0x02,Grenze
 String3=0x04,Boundary
 String4=0x03,Gemeentegrens
+String5=0x08,Límite provicial/municipal
 String7=0x15,Granica
 String8=0x10,Limite Municipal
 String9=0x05,Confine
@@ -1640,6 +1670,7 @@
 String2=0x02,Landesgrenze
 String3=0x04,State Boundary
 String4=0x03,Provinciegrens 3
+String5=0x08,Límite regional
 String7=0x15,Granica województwa
 String8=0x10,Limite Estadual
 String9=0x05,Confine regionale
@@ -1670,6 +1701,7 @@
 String2=0x02,Staatsgrenze
 String3=0x04,National boundary
 String4=0x03,Landsgrens
+String5=0x08,Frontera internacional
 String7=0x15,Granica państwa
 String8=0x10,Limite Nacional
 String9=0x05,Confine nazionale
@@ -1690,6 +1722,7 @@
 String2=0x02,Fluß, Kanal
 String3=0x04,River, Canal
 String4=0x03,Rivier, Kanaal
+String5=0x08,Río/Canal
 String7=0x15,Rzeka, Kanał
 String8=0x10,Rio / Canal
 String9=0x05,Fiume/Canale
@@ -1763,7 +1796,7 @@
 type=0x26
 ;GRMN_TYPE: Water Features/INTERMITTENT_STREAM/Intermittent or dry stream, creek, or ditch/Non NT
 UseOrientation=Y
-Xpm="32 3 2  1"
+Xpm="32 3 2 1"
 "! c #AAD3DF"
 "  c none"
 " !!!!!   !!!!!   !!!!!   !!!!!  "
@@ -1774,6 +1807,7 @@
 String1=0x01,Ruisseau intermittent
 String2=0x02,Wasserlauf (periodisch)
 String4=0x03,Beek (Periodiek)
+String5=0x08,Arroyo intermitente
 String7=0x15,Strumień
 String8=0x10,Córrego intermitente
 String9=0x05,Torrente (discontinuo)
@@ -1793,6 +1827,7 @@
 String1=0x01,Piste d’aviation
 String2=0x02,Startbahn
 String4=0x03,Landingsbaan
+String5=0x08,Pista de aterrizaje
 String7=0x15,Pas startowy
 String8=0x10,Pista
 String9=0x05,Pista di aviazione
@@ -1817,6 +1852,7 @@
 String1=0x01,Pipeline
 String2=0x02,Rohr
 String4=0x03,Pijpleiding
+String5=0x08,Tubería
 String7=0x15,Rurociąg
 String8=0x10,Tubulação
 String9=0x05,Conduttura
@@ -2008,6 +2044,7 @@
 String1=0x01,Route (en travaux)
 String2=0x02,Weg (Im bau)
 String4=0x03,Weg (In aanleg)
+String5=0x08,Carretera en construcción
 String7=0x15,Droga (w budowie)
 String8=0x10,Rodovia em construção
 String9=0x05,Strada in costruzione
@@ -5943,6 +5980,7 @@
 String1=0x01,Falaise
 String2=0x02,Klippe
 String4=0x03,Klif
+String5=0x08,Acantilado
 String7=0x15,Klif
 String8=0x10,Penhasco
 String9=0x05,Dirupo