Index: doc/styles/about.txt
===================================================================
--- doc/styles/about.txt	(revision 4458)
+++ doc/styles/about.txt	(working copy)
@@ -14,9 +14,9 @@
 People who have contributed suggestions and corrections to this document
 are:
 Carlos Dávila,
-Geoff Sherlock
+Geoff Sherlock,
+Ticker Berkin
 
-
 The list of nicknames of everyone that had modified the wiki pages at the time that
 this manual was created is as follows:
 Brogo,
Index: doc/styles/rules.txt
===================================================================
--- doc/styles/rules.txt	(revision 4458)
+++ doc/styles/rules.txt	(working copy)
@@ -244,9 +244,9 @@
 Functions calculate a specific property of an OSM element.
 
 .Style functions
-[width="100%",cols="2,1,1,1,5",options="header"]
+[width="100%",cols="5,1,1,1,11",options="header"]
 |=====
-|Function |Node |Way |Relation |Description
+|Function |Node |Way |Rel. |Description
 |length()      |  | x  | x  |
 Calculates the length in m. For relations its the sum of all member length (including sub relations).
 
@@ -282,8 +282,8 @@
 Retrieves the id of the OSM element. This can be useful for style debugging purposes. Note that due to internal changes like merging, cutting etc. 
 some element ids are changed and some have a faked id > 4611686018427387904.  
 
-|is_in(tag,value,method)   | x | x  |  |
-+true+ if the element is in polygon(s) having the specified *tag=value* according to the *method*, +false+ otherwise.
+|is_in(*tag*,*value*,*method*)   | x | x  |  |
++true+ if the element is in polygon(s) having the specified *tag*=*value* according to the *method*, +false+ otherwise.
 The methods available depend on the Style section:
 
 polygons:
Index: doc/styles/style-manual.txt
===================================================================
--- doc/styles/style-manual.txt	(revision 4458)
+++ doc/styles/style-manual.txt	(working copy)
@@ -1,6 +1,6 @@
 = Conversion Style manual
 The mkgmap team
-:pubdate: January 2013
+:pubdate: set to date of pdf generation
 :toc:
 :numbered:
 :doctype: book
@@ -9,6 +9,18 @@
 :description: Describes the style language that converts from OSM tags to Garmin types.
 :max-width: 58em
 
+////
+To generate style-manual.pdf you will need asciidoc, fop, python-pygments, mkgmap-pygments.
+eg. for a Fedora system, as superuser:
+# dnf install asciidoc.noarch
+# dnf install fop.noarch
+# dnf install python-pygments.noarch
+# pip install mkgmap-pygments
+
+Then, as normal user, cd to this directory (doc/styles) and
+$ make pdf
+////
+
 :frame: topbot
 :grid: rows
 
Index: src/uk/me/parabola/mkgmap/osmstyle/function/IsInFunction.java
===================================================================
--- src/uk/me/parabola/mkgmap/osmstyle/function/IsInFunction.java	(revision 4458)
+++ src/uk/me/parabola/mkgmap/osmstyle/function/IsInFunction.java	(working copy)
@@ -20,6 +20,7 @@
 import java.util.Set;
 import java.util.stream.Collectors;
 
+import uk.me.parabola.imgfmt.ExitException;
 import uk.me.parabola.imgfmt.app.Area;
 import uk.me.parabola.imgfmt.app.Coord;
 import uk.me.parabola.log.Logger;
@@ -144,7 +145,7 @@
 		// 1: polygon tagName
 		// 2: value for above tag
 		// 3: method keyword, see above
-		log.info("isInFunction", System.identityHashCode(this));
+		log.debug("isInFunction", System.identityHashCode(this));
 	}
 
 	private void resetHasFlags() {
@@ -155,7 +156,7 @@
 	}
 
 	public String calcImpl(Element el) {
-		log.info("calcImpl", System.identityHashCode(this), kind, params, el);
+		log.debug("calcImpl", System.identityHashCode(this), kind, params, el);
 		assert qt != null : "invoked the non-augmented instance";
 		if (qt.isEmpty())
 			return String.valueOf(false);
@@ -171,9 +172,11 @@
 			case POLYGON:
 				doPolygonTest((Way) el);
 				break;
+			default:
+				throw new ExitException("Bad FeatureKind: " + kind);
 			}
 		} catch (CanStopProcessing e) {}
-		log.info("done", System.identityHashCode(this), hasIn, hasOn, hasOut);
+		log.debug("done", System.identityHashCode(this), hasIn, hasOn, hasOut);
 		if (!hasIn && !hasOn)
 			hasOut = true;
 		return String.valueOf(method.mapFlags(hasIn, hasOn, hasOut));
@@ -189,7 +192,7 @@
 	@Override
 	public void setParams(List<String> params, FeatureKind kind) {
 		super.setParams(params, kind);
-		log.info("setParams", System.identityHashCode(this), kind, params);
+		log.debug("setParams", System.identityHashCode(this), kind, params);
 		String methodStr = params.get(2);
 		boolean knownMethod = false;
 		List<String> methodsForKind = new ArrayList<>();
@@ -209,7 +212,7 @@
 	}
 
 	private void setIn() {
-		log.info("setIn", hasIn, hasOn, hasOut);
+		log.debug("setIn", hasIn, hasOn, hasOut);
 		hasIn = true;
 		if (method.canStopIn() || hasOut)
 			throw new CanStopProcessing();
@@ -216,13 +219,13 @@
 	}
 
 	private void setOn() {
-		log.info("setOn", hasIn, hasOn, hasOut);
+		log.debug("setOn", hasIn, hasOn, hasOut);
 		hasOn = true;
 		if (method.canStopOn() || (hasIn && hasOut))
 			throw new CanStopProcessing();
 	}
 	private void setOut() {
-		log.info("setOut", hasIn, hasOn, hasOut);
+		log.debug("setOut", hasIn, hasOn, hasOut);
 		hasOut = true;
 		if (method.canStopOut() || hasIn)
 			throw new CanStopProcessing();
@@ -229,7 +232,7 @@
 	}
 
 	private void setHasFromFlags(int flags) {
-		log.info("setFlags", flags);
+		log.debug("setFlags", flags);
 		if ((flags & IsInUtil.ON) != 0)
 			setOn();
 		if ((flags & IsInUtil.IN) != 0)
@@ -272,6 +275,8 @@
 				// hole checking is a separate pass
 				setOn(); // don't care about setIn()
 			break;
+		default:
+			throw new ExitException("Bbad point method: " + method);
 		}
 	}
 
@@ -285,7 +290,7 @@
 			List<List<Coord>> outers = new ArrayList<>();
 			List<List<Coord>> holes = new ArrayList<>();
 			IsInUtil.mergePolygons(polygons, outers, holes);
-			log.info("pointMerge", polygons.size(), outers.size(), holes.size());
+			log.debug("pointMerge", polygons.size(), outers.size(), holes.size());
 			for (List<Coord> shape : outers)
 				checkPointInShape(c, shape, holes);
 			if (method == MethodArg.POINT_ON && !holes.isEmpty())
@@ -293,7 +298,7 @@
 				for (List<Coord> hole : holes)
 					checkPointInShape(c, hole, null);
 		} else { // just one polygon or IN_OR_ON, which can do one-by-one
-			log.info("point1by1", polygons.size());
+			log.debug("point1by1", polygons.size());
 			for (Way polygon : polygons)
 				checkPointInShape(c, polygon.getPoints(), null);
 		}
@@ -311,7 +316,7 @@
 		boolean foundSomething = false;
 		for (List<Coord> hole : holes) {
 			int flags = IsInUtil.isLineInShape(polyLine, hole, elementBbox);
-			log.info("checkhole", flags);
+			log.debug("checkhole", flags);
 			if ((flags & IsInUtil.IN) != 0) {
 				setOut();
 				if ((flags & IsInUtil.ON) != 0)
@@ -332,7 +337,7 @@
 	private void checkHoleInThis(List<Coord> polyLine, List<List<Coord>> holes, Area elementBbox) {
 		for (List<Coord> hole : holes) {
 			int flags = IsInUtil.isLineInShape(hole, polyLine, elementBbox);
-			log.info("holeInThis", flags);
+			log.debug("holeInThis", flags);
 			if ((flags & IsInUtil.IN) != 0 ||
 			    (flags == IsInUtil.ON)) { // exactly on hole
 				setOut();
@@ -346,26 +351,26 @@
 		Area elementBbox = Area.getBBox(polyLine);
 		Set<Way> polygons = qt.get(elementBbox).stream().map(e -> (Way) e)
 				.collect(Collectors.toCollection(LinkedHashSet::new));
-		if (log.isInfoEnabled()) {
-			log.info("line", polyLine);
-			log.info(polygons.size(), "polygons");
+		if (log.isDebugEnabled()) {
+			log.debug("line", polyLine);
+			log.debug(polygons.size(), "polygons");
 			for (Way polygon : polygons)
-				log.info("polygon", polygon.getPoints());
+				log.debug("polygon", polygon.getPoints());
 		}
 		if (method.needMerge() && polygons.size() > 1) { // ALL-like methods need to merge shapes
 			List<List<Coord>> outers = new ArrayList<>();
 			List<List<Coord>> holes = new ArrayList<>();
 			IsInUtil.mergePolygons(polygons, outers, holes);
-			if (log.isInfoEnabled()) {
-				log.info(outers.size(), "outers", holes.size(), "holes");
+			if (log.isDebugEnabled()) {
+				log.debug(outers.size(), "outers", holes.size(), "holes");
 				for (List<Coord> shape : outers)
-					log.info("outer", shape);
+					log.debug("outer", shape);
 				for (List<Coord> hole : holes)
-					log.info("hole", hole);
+					log.debug("hole", hole);
 			}
 			for (List<Coord> shape : outers) {
 				int flags = IsInUtil.isLineInShape(polyLine, shape, elementBbox);
-				log.info("checkShape", flags);
+				log.debug("checkShape", flags);
 				if ((flags & IsInUtil.IN) != 0) { // this shape is the one to consider
 					if ((flags & IsInUtil.ON) != 0)
 						setOn();
@@ -426,7 +431,7 @@
 
 	@Override
 	public void augmentWith(ElementSaver elementSaver) {
-		log.info("augmentWith", System.identityHashCode(this), kind, params);
+		log.debug("augmentWith", System.identityHashCode(this), kind, params);
 		// the cached function mechanism creates an instance for each occurance in the rule file
 		// but then just uses one of them for augmentWith() and calcImpl().
 		if (qt != null)